【HDU1074】Doing Homework(状压dp)

题目链接

Doing Homework

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 13630    Accepted Submission(s): 6583


 

Problem Description

Ignatius has just come back school from the 30th ACM/ICPC. Now he has a lot of homework to do. Every teacher gives him a deadline of handing in the homework. If Ignatius hands in the homework after the deadline, the teacher will reduce his score of the final test, 1 day for 1 point. And as you know, doing homework always takes a long time. So Ignatius wants you to help him to arrange the order of doing homework to minimize the reduced score.

 

 

Input

The input contains several test cases. The first line of the input is a single integer T which is the number of test cases. T test cases follow.
Each test case start with a positive integer N(1<=N<=15) which indicate the number of homework. Then N lines follow. Each line contains a string S(the subject's name, each string will at most has 100 characters) and two integers D(the deadline of the subject), C(how many days will it take Ignatius to finish this subject's homework).

Note: All the subject names are given in the alphabet increasing order. So you may process the problem much easier.

 

 

Output

For each test case, you should output the smallest total reduced score, then give out the order of the subjects, one subject in a line. If there are more than one orders, you should output the alphabet smallest one.

 

 

Sample Input

 

2 3 Computer 3 3 English 20 1 Math 3 2 3 Computer 3 3 English 6 3 Math 6 3

 

 

Sample Output

 
2 Computer Math English 3 Computer English Math

Hint

In the second test case, both Computer->English->Math and Computer->Math->English leads to reduce 3 points, but the word "English" appears earlier than the word "Math", so we choose the first order. That is so-called alphabet order.

 

【题意】

Ignatius有n种作业,每种作业都有一个截止日期和需要的时间,如果超过截止日期完成的话会扣相应分数(按超过的天数计算),问Ignatius最少小扣多少分,并且将他完成作业的顺序输出,如果有多种答案输出字典序最小的。(输入按字典序)

【解题思路】

将每种作业表示为01状态,表示完成与未完成,dp[i]表示在状态i下所扣的最少分数,所以状态转移方程为:dp[i]=min(dp[i],dp[i-k]+tmp)。tmp为完成k时所扣除的分数。然后需要注意的是枚举作业的时候需要倒序,因为输出需要按字典序,那么更新的时候就会把最小的作为答案。

(dp真奇妙!)

【代码】

#include<bits/stdc++.h>
using namespace std;
const int maxn=(1<<15)+50;
const int INF=0x3f3f3f3f;
struct Node
{
    string name;
    int dead,t;
}node[20];
int dp[maxn],pre[maxn],s[maxn],n;
vector<int>ans;
int main()
{
    int T;
    scanf("%d",&T);
    while(T--)
    {
        ans.clear();
        scanf("%d",&n);
        for(int i=0;i<n;i++)
            cin>>node[i].name>>node[i].dead>>node[i].t;
        for(int i=1;i<(1<<n);i++)
        {
            dp[i]=INF;
            for(int j=n-1;j>=0;j--)
            {
                int k=(1<<j);
                if((i&k)==0)continue;
                int tmp=s[i-k]+node[j].t-node[j].dead;
                if(tmp<0)tmp=0;
                if(dp[i]>dp[i-k]+tmp)
                {
                    dp[i]=dp[i-k]+tmp;
                    s[i]=s[i-k]+node[j].t;
                    pre[i]=j;
                }
            }
        }
        printf("%d\n",dp[(1<<n)-1]);
        int x=(1<<n)-1;
        for(int i=0;i<n;i++)
        {
            ans.push_back(pre[x]);
            x=x-(1<<pre[x]);
        }
        for(int i=ans.size()-1;i>=0;i--)
            cout<<node[ans[i]].name<<endl;
    }

}

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值